Description

While working on the messages of "wrong number of arguments" error (see #6085), I realized that the new named parameter feature

can lead to misleading error messages:

def foo(x: 42)

end

arg = {x: :bar}

foo(arg) # => nil (no error)

arg = :bar

foo(arg) # => ArgumentError: wrong number of arguments (1 for 0)

It would be better if the wording was changed for methods accepting options. Maybe something like:

foo(arg) # => ArgumentError: wrong number of arguments (1 for 0 **)

Suggestions?

Related issues:

Related to Ruby - Bug #6085: Treatment of Wrong Number of Arguments Closed 02/25/2012

Related to Ruby - Feature #5474: keyword argument Closed 10/23/2011

History

#1 - 03/11/2012 05:44 PM - ko1 (Koichi Sasada)

- Assignee set to mame (Yusuke Endoh)

#2 - 03/18/2012 06:46 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

#3 - 04/24/2012 08:18 PM - mame (Yusuke Endoh)

- Assignee changed from mame (Yusuke Endoh) to matz (Yukihiro Matsumoto)

Matz, what do you think?

I'm not against this.  But I'm not sure how surprising this behavior is,

until I encounter it in actual use case.

"(1 for 0 **)" is not very good-looking, but I have no alternative idea.

--

Yusuke Endoh mame@tsg.ne.jp

#4 - 07/14/2012 04:24 PM - matz (Yukihiro Matsumoto)

- Status changed from Assigned to Rejected

Even though I understand the point, I am against the expression "(1 for 0 **)".

So until some one come up with better expression, we leave this as it is now.

Matz.
